clear all
clc

load X.mat
rho = 0.025;
T = 100;
epsilon = 2;

for method = 0:2
    if method == 0
        fprintf('*** Forward-backward Splitting ***\n\n');
    elseif method == 1
        fprintf('*** Basic Proximal Gradient ***\n\n');
    else
        fprintf('*** Accelerated Proximal Gradient ***\n\n');
    end
    for sampler = 0:3
        clear sampling
        if sampler == 0
            sampling.method = 'exact';
            sampling.samples = 't^(1/2+0.05)';
        elseif sampler == 1
            sampling.method = 'uniform';
            sampling.samples = 't^(1/2+0.05)';
        elseif sampler == 2
            sampling.method = 'meanfield';
            sampling.samples = 't^(1/2+0.05)';
        else
            sampling.method = 'gibbs';
            sampling.samples = 't^(1/2+0.05)';
            sampling.iterations = 5;
        end
        if method == 0
            [W b rule] = learn_stochastic_ising(X,rho,T,sampling,epsilon);
        elseif method == 1
            [W b rule] = learn_sproxgrad_ising(X,rho,T,sampling,epsilon,false);
        else
            [W b rule] = learn_sproxgrad_ising(X,rho,T,sampling,epsilon,true);
        end
        for i = 1:length(rule)
            disp(['sampling: ' sampling.method ', rule: ' rule{i}]);
            disp([W{i} nan(size(W{i},1),1) b{i}]);
        end
    end
end
